// CircleAppView.cpp : implementation of the CCircleAppView class
//

#include "stdafx.h"
#include "CircleApp.h"

#include "CircleAppDoc.h"
#include "CircleAppView.h"
#include "DiameterDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CCircleAppView

IMPLEMENT_DYNCREATE(CCircleAppView, CView)

BEGIN_MESSAGE_MAP(CCircleAppView, CView)
	//{{AFX_MSG_MAP(CCircleAppView)
	ON_WM_LBUTTONDOWN()
	ON_COMMAND(ID_CIRCLE_CHANGECOLOR, OnCircleChangecolor)
	ON_COMMAND(ID_CIRCLE_CHANGEDIAMETER, OnCircleChangediameter)
	//}}AFX_MSG_MAP
	// Standard printing commands
	ON_COMMAND(ID_FILE_PRINT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_DIRECT, CView::OnFilePrint)
	ON_COMMAND(ID_FILE_PRINT_PREVIEW, CView::OnFilePrintPreview)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CCircleAppView construction/destruction

CCircleAppView::CCircleAppView()
{
	// TODO: add construction code here

	m_currentColor = RGB(255,0,0);
	m_currentDiameter = 40;
}

CCircleAppView::~CCircleAppView()
{
}

BOOL CCircleAppView::PreCreateWindow(CREATESTRUCT& cs)
{
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return CView::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CCircleAppView drawing

void CCircleAppView::OnDraw(CDC* pDC)
{
	CCircleAppDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

	// TODO: add draw code for native data here
    int size = pDoc->m_circleArray.GetSize();

	for (int x=0; x<size; ++x)
	{
		CircleStruct* circle =
			(CircleStruct*)pDoc->m_circleArray.GetAt(x);
		int radius = circle->diameter/2;
		int x1 = circle->point.x-radius;
	    int y1 = circle->point.y-radius;
	    int x2 = circle->point.x+radius;
		int y2 = circle->point.y+radius;
	    COLORREF color = circle->color;
		CBrush brush(color);
	    CBrush* oldBrush = pDC->SelectObject(&brush);
	    pDC->Ellipse(x1, y1, x2, y2);
		pDC->SelectObject(oldBrush);
	}
}

/////////////////////////////////////////////////////////////////////////////
// CCircleAppView printing

BOOL CCircleAppView::OnPreparePrinting(CPrintInfo* pInfo)
{
	// default preparation
	return DoPreparePrinting(pInfo);
}

void CCircleAppView::OnBeginPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add extra initialization before printing
}

void CCircleAppView::OnEndPrinting(CDC* /*pDC*/, CPrintInfo* /*pInfo*/)
{
	// TODO: add cleanup after printing
}

/////////////////////////////////////////////////////////////////////////////
// CCircleAppView diagnostics

#ifdef _DEBUG
void CCircleAppView::AssertValid() const
{
	CView::AssertValid();
}

void CCircleAppView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

CCircleAppDoc* CCircleAppView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CCircleAppDoc)));
	return (CCircleAppDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CCircleAppView message handlers

void CCircleAppView::OnLButtonDown(UINT nFlags, CPoint point) 
{
	// TODO: Add your message handler code here and/or call default
	
	// Draw the new circle.
	CClientDC clientDC(this);
	CBrush brush(m_currentColor);
	CBrush* oldBrush = clientDC.SelectObject(&brush);
	int radius = m_currentDiameter / 2;
	clientDC.Ellipse(point.x-radius, point.y-radius,
		point.x+radius, point.y+radius);
	clientDC.SelectObject(oldBrush);

	// Store the new circle in the document.
	CCircleAppDoc* pDoc = GetDocument();
	CircleStruct* circle = new CircleStruct;
	circle->point = point;
	circle->color = m_currentColor;
	circle->diameter = m_currentDiameter;
	pDoc->m_circleArray.Add(circle);

	CView::OnLButtonDown(nFlags, point);
}

void CCircleAppView::OnUpdate(CView* pSender, LPARAM lHint, CObject* pHint) 
{
	// TODO: Add your specialized code here and/or call the base class
	
	Invalidate();	
}

void CCircleAppView::OnCircleChangecolor() 
{
	// TODO: Add your command handler code here
	
	CColorDialog dialog;
	int result = dialog.DoModal();
	if (result == IDOK)
		m_currentColor = dialog.GetColor();
}

void CCircleAppView::OnCircleChangediameter() 
{
	// TODO: Add your command handler code here
	
	CDiameterDlg dialog;
	dialog.m_diameter = m_currentDiameter;
	int result = dialog.DoModal();
	if (result == IDOK)
		m_currentDiameter = dialog.m_diameter;
}
